VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.1#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   Caption         =   "Test Somarsoft RGEDIT.DLL"
   ClientHeight    =   5430
   ClientLeft      =   1095
   ClientTop       =   1515
   ClientWidth     =   7500
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   5430
   ScaleWidth      =   7500
   Begin VB.CommandButton btnTest 
      Caption         =   "Quick Test"
      Height          =   375
      Left            =   5400
      TabIndex        =   2
      Top             =   240
      Width           =   1455
   End
   Begin VB.Frame frmProfile 
      Height          =   1095
      Left            =   240
      TabIndex        =   3
      Top             =   720
      Width           =   7095
      Begin VB.ComboBox lstHives 
         Height          =   300
         Left            =   1560
         Style           =   2  'Dropdown List
         TabIndex        =   6
         Top             =   240
         Width           =   5295
      End
      Begin VB.TextBox txtProfile 
         Height          =   285
         Left            =   1560
         TabIndex        =   7
         Text            =   "c:\common\hidden\profiles\user1.usr"
         Top             =   600
         Width           =   5295
      End
      Begin VB.OptionButton optPath 
         Caption         =   "Profile path:"
         Height          =   255
         Left            =   120
         TabIndex        =   5
         Top             =   600
         Value           =   -1  'True
         Width           =   1215
      End
      Begin VB.OptionButton optHive 
         Caption         =   "Registry Hive:"
         Height          =   255
         Left            =   120
         TabIndex        =   4
         Top             =   240
         Width           =   1455
      End
   End
   Begin VB.CommandButton btnRead 
      Caption         =   "Replace registry with contents of file..."
      Height          =   375
      Left            =   2280
      TabIndex        =   1
      Top             =   240
      Width           =   3015
   End
   Begin VB.CommandButton btnWrite 
      Caption         =   "Write registry to file..."
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   1935
   End
   Begin VB.ListBox lstResults 
      Height          =   2790
      Left            =   240
      TabIndex        =   8
      Top             =   1920
      Width           =   7095
   End
   Begin MSComDlg.CommonDialog FileDlg 
      Left            =   0
      Top             =   4920
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   327680
      CancelError     =   -1  'True
      Filter          =   "Text (*.txt)|*.txt|All files (*.*)|*.*"
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim f_NumHives As Long
Dim f_szHives() As String
Dim f_hHives() As Long


Private Function ByteToString(abValue() As Byte, length As Long) As String
    Dim c1 As Integer, c2 As Integer, i As Integer, hexchars$, s$
    hexchars$ = "0123456789ABCDEF"
    For i = 0 To length - 1
        If i Mod 100 = 0 Then DoEvents
        c1 = (abValue(i) \ 16) And 15
        c2 = abValue(i) And 15
        s$ = s$ + Mid$(hexchars$, c1 + 1, 1) + Mid$(hexchars$, c2 + 1, 1)
    Next i
    ByteToString = s$
End Function

Private Sub DeleteKeys(hProfile As Long)
    Dim rc As Long, szName As String, length As Long, hEnum As Long
    Dim keys(100) As String, count As Long
    
    count = 0
    rc = RgedEnumKeysInit(hProfile, "", hEnum)
    If rc <> 0 Then
        PrintError
    Else
        Do While True
            szName = String$(1024, " ")
            rc = RgedEnumKeys(hEnum, szName, 1024, length)
            If rc > 0 Then PrintError
            If rc <> 0 Then Exit Do
            keys(count) = Left$(szName, length)
            count = count + 1
        Loop
        Do While count > 0
            count = count - 1
            rc = RgedDeleteKey(hProfile, "", keys(count))
            If rc <> 0 Then
                PrintError
            Else
                lstResults.AddItem "delete " + keys(count)
            End If
        Loop
    End If
End Sub

Private Function GetFile(fSave As Integer) As String
    Dim cd As String
    cd = CurDir
    GetFile = ""
    On Error GoTo Cancel
    If fSave Then
        FileDlg.ShowSave
    Else
        FileDlg.ShowOpen
    End If
    On Error GoTo 0
    GetFile = FileDlg.filename
Cancel:
    ChDir cd
End Function

Private Sub GetHive(szHive As String, hHive As Long)
    If lstHives.ListIndex < 0 Then
        lstHives.ListIndex = 0
    ElseIf lstHives.ListIndex >= f_NumHives Then
        lstHives.ListIndex = f_NumHives - 1
    End If
    szHive = f_szHives(lstHives.ListIndex)
    hHive = f_hHives(lstHives.ListIndex)
End Sub

Private Function ReadData(file As Integer, hProfile As Long) As Long
    Dim rc As Long, numkeys As Long, rectype As String, szKey As String
    Dim szName As String, length As Long, szValue As String, ValueType As String
    Dim dwValue As Long, abValue(32000) As Byte, szMulti As String, lenMulti As Long
    Dim inbuf As String, szParent As String, linenum As Long, i As Long
    
    linenum = 0
    numkeys = 1
    szKey = ""
    szMulti = ""
    lenMulti = 0
    Do Until EOF(file)
        DoEvents
        
        Line Input #file, inbuf
        linenum = linenum + 1
        rectype = Left$(inbuf, 3)
        inbuf = Mid$(inbuf, 5)
        
        If rectype = "key" Then
            If Mid$(inbuf, 6, 1) <> "," Then GoTo error
            length = CInt(Left$(inbuf, 5))
            szParent = Mid$(inbuf, 7, length)
            inbuf = Mid$(inbuf, 8 + length)
            
            If Mid$(inbuf, 6, 1) <> "," Then GoTo error
            length = CInt(Left$(inbuf, 5))
            szName = Mid$(inbuf, 7, length)
            
            rc = RgedCreateKey(hProfile, szParent, szName)
            If rc <> 0 Then
                PrintError
            Else
                If szParent = "" Then
                    szKey = szName
                Else
                    szKey = szParent + "\" + szName
                End If
                numkeys = numkeys + 1
            End If
        ElseIf rectype = "val" Then
            i = InStr(inbuf, ",")
            If i = 0 Then GoTo error
            ValueType = Left$(inbuf, i - 1)
            inbuf = Mid$(inbuf, i + 1)
            
            If Mid$(inbuf, 6, 1) <> "," Then GoTo error
            length = CInt(Left$(inbuf, 5))
            szName = Mid$(inbuf, 7, length)
            inbuf = Mid$(inbuf, 8 + length)
            
            If Mid$(inbuf, 6, 1) <> "," Then GoTo error
            length = CInt(Left$(inbuf, 5))
            szValue = Mid$(inbuf, 7, length)
            
            Select Case ValueType
                Case "REG_SZ"
                    rc = RgedSetString(hProfile, szKey, szName, szValue, REG_SZ)
                Case "REG_EXPAND_SZ"
                    rc = RgedSetString(hProfile, szKey, szName, szValue, REG_EXPAND_SZ)
                Case "REG_MULTI_SZ"
                    szMulti = szMulti + Chr$(0)
                    lenMulti = lenMulti + 1
                    rc = RgedSetValue(hProfile, szKey, szName, ByVal szMulti, lenMulti, REG_MULTI_SZ)
                    szMulti = ""
                    lenMulti = 0
                Case "REG_DWORD"
                    dwValue = szValue
                    rc = RgedSetDword(hProfile, szKey, szName, dwValue, REG_DWORD)
                Case "REG_BINARY"
                    length = StringToByte(szValue, abValue, 32000)
                    rc = RgedSetValue(hProfile, szKey, szName, abValue(0), length, REG_BINARY)
                Case Else
                    lstResults.AddItem "unknown type: key=" + szKey + " value=" + szName
                    rc = 0
            End Select
            If rc <> 0 Then
                PrintError
            End If
        ElseIf rectype = "vsz" Then
            If Mid$(inbuf, 6, 1) <> "," Then GoTo error
            length = CInt(Left$(inbuf, 5))
            szValue = Mid$(inbuf, 7, length)
            
            szMulti = szMulti + szValue + Chr$(0)
            lenMulti = lenMulti + Len(szValue) + 1
        Else
            GoTo error
            Exit Function
        End If
    Loop
    
    ReadData = numkeys
    Exit Function
    
error:
    lstResults.AddItem "==>Line " & Str$(linenum) & " is invalid"
    ReadData = 0

End Function


Private Function RemoveUnprintables(sz As String) As Integer
    Dim i As Long, j As Integer
    RemoveUnprintables = 0
    For i = 1 To Len(sz)
        j = Asc(Mid$(sz, i, 1))
        If j > 0 And j < 32 Then
            sz = Left$(sz, i - 1) & " " & Mid$(sz, i + 1)
            RemoveUnprintables = 1
        End If
    Next
End Function

Private Function StringToByte(sz As String, abValue() As Byte, maxlen As Long) As Long
    Dim c1 As Integer, c2 As Integer, i As Long, j As Long, hexchars$
    hexchars$ = "0123456789ABCDEF"
    j = 0
    For i = 1 To Len(sz) Step 2
        If j = maxlen Then
            Exit For
        End If
        c1 = InStr(hexchars$, Mid$(sz, i, 1)) - 1
        c2 = InStr(hexchars$, Mid$(sz, i + 1, 1)) - 1
        abValue(j) = c1 * 16 + c2
        j = j + 1
    Next i
    StringToByte = j
End Function

Private Function WriteData(file As Integer, hProfile As Long, szKey As String) As Long
    Dim rc As Long, hEnum As Long, count As Long
    Dim szName As String, length As Long, szValue As String, ValueType As Long
    Dim dwValue As Long, abValue(32000) As Byte
    Dim szMulti As String, schar As Integer, echar As Integer
    Dim maxlen As Long, outbuf As String
    
    count = 1
    
    DoEvents
    
        '
        ' Process Values
        '
    rc = RgedEnumValuesInit(hProfile, szKey, hEnum)
    If rc <> 0 Then
        PrintError
    Else
        Do While True
            DoEvents
            szName = String$(4096, " ")
            rc = RgedEnumValues(hEnum, szName, 4096, length, ValueType)
            If rc > 0 Then PrintError
            If rc <> 0 Then Exit Do
            szName = Left$(szName, length)
            Select Case ValueType
                Case REG_SZ, REG_EXPAND_SZ:
                    szValue = String$(4096, " ")
                    rc = RgedGetString(hProfile, szKey, szName, szValue, 4096, length, ValueType)
                    If rc <> 0 Then
                       PrintError
                    Else
                        szValue = Left$(szValue, length)
                        If RemoveUnprintables(szValue) = 1 Then
                            lstResults.AddItem "==>removing unprintables, key=" + szKey + " value=" + szName
                        End If
                        If ValueType = REG_SZ Then
                            outbuf = "val,REG_SZ,"
                        Else
                            outbuf = "val,REG_EXPAND_SZ,"
                        End If
                        outbuf = outbuf & _
                                 Format$(Len(szName), "00000") & "," & szName & "," & _
                                 Format$(Len(szValue), "00000") & "," & szValue
                        Print #file, outbuf
                    End If
                Case REG_DWORD:
                    rc = RgedGetDword(hProfile, szKey, szName, dwValue, ValueType)
                    If rc <> 0 Then
                        PrintError
                    Else
                        szValue = Str$(dwValue)
                        outbuf = "val,REG_DWORD," & _
                                 Format$(Len(szName), "00000") & "," & szName & "," & _
                                 Format$(Len(szValue), "00000") & "," & szValue
                        Print #file, outbuf
                    End If
                Case REG_BINARY:
                    rc = RgedGetValue(hProfile, szKey, szName, abValue(0), 32000, length, ValueType)
                    If rc <> 0 Then
                        PrintError
                    Else
                        szValue = ByteToString(abValue, length)
                        outbuf = "val,REG_BINARY," & _
                                 Format$(Len(szName), "00000") & "," & szName & "," & _
                                 Format$(Len(szValue), "00000") & "," & szValue
                        Print #file, outbuf
                    End If
                Case REG_MULTI_SZ:
                    szValue = String$(4096, " ")
                        ' specify 4095 as buflen to allow looking one byte ahead during parsing
                    rc = RgedGetValue(hProfile, szKey, szName, ByVal szValue, 4095, length, ValueType)
                    If rc <> 0 Then
                        PrintError
                    Else
                        szValue = Left$(szValue, length)
                        If RemoveUnprintables(szValue) = 1 Then
                            lstResults.AddItem "==>removing unprintables, key=" + szKey + " value=" + szName
                        End If
                        schar = 1
                        echar = 1
                        Do While echar <= length
                            If echar = length Or Asc(Mid$(szValue, echar, 1)) = 0 Then
                                If echar > schar Then
                                    szMulti = Mid$(szValue, schar, echar - schar)
                                    outbuf = "vsz," & Format$(Len(szMulti), "00000") & "," & szMulti
                                    Print #file, outbuf
                                End If
                                schar = echar + 1
                            End If
                            echar = echar + 1
                        Loop
                        outbuf = "val,REG_MULTI_SZ," & _
                                 Format$(Len(szName), "00000") & "," & szName & ",00000,"
                        Print #file, outbuf
                    End If
                Case Else:
                    lstResults.AddItem "==>Invalid valuetype: key=" + szKey + " value=" + szName
            End Select
        Loop
    End If
        '
        ' Process Subkeys
        '
    rc = RgedEnumKeysInit(hProfile, szKey, hEnum)
    If rc <> 0 Then
        PrintError
    Else
        Do While True
            szName = String$(1024, " ")
            rc = RgedEnumKeys(hEnum, szName, 1024, length)
            If rc > 0 Then PrintError
            If rc <> 0 Then Exit Do
            szName = Left$(szName, length)
            outbuf = "key," & _
                     Format$(Len(szKey), "00000") & "," & szKey & "," & _
                     Format$(Len(szName), "00000") & "," & szName
            Print #file, outbuf
            If szKey <> "" Then
                szName = szKey + "\" + szName
            End If
            count = count + WriteData(file, hProfile, szName)
        Loop
    End If
    
    WriteData = count
End Function
Private Sub PrintError()
    Dim rc As Long, sz As String, l As Long
    sz = String$(4096, " ")
    rc = RgedGetError(sz, 4096, l)
    If rc <> 0 Then
        sz = Left$(sz, l)
        lstResults.AddItem "==>" + sz
    End If
End Sub


Private Sub btnTest_Click()
    Dim hProfile As Long, rc As Long, start_time, end_time
    Dim hEnum As Long, szName As String, length As Long
    Dim szHive As String, hHive As Long

    start_time = Time
    lstResults.Clear
    RgedSetSilent
    MousePointer = 11
    If optHive = True Then
        GetHive szHive, hHive
        rc = RgedOpenLocalHive(hHive, hProfile)
        lstResults.AddItem "Dump data for " & szHive
    Else
        rc = RgedLoadProfile("RGEDIT_TEST", txtProfile, hProfile)
        lstResults.AddItem "Dump data for " + txtProfile
    End If
    If rc <> 0 Then
        PrintError
    Else
        lstResults.AddItem "Subkeys of root"
        rc = RgedEnumKeysInit(hProfile, "", hEnum)
        If rc <> 0 Then
            PrintError
        Else
            Do While True
                szName = String$(1024, " ")
                rc = RgedEnumKeys(hEnum, szName, 1024, length)
                If rc > 0 Then PrintError
                If rc <> 0 Then Exit Do
                szName = Left$(szName, length)
                lstResults.AddItem "   " & szName
            Loop
        End If
        rc = RgedUnloadProfile(hProfile)
    End If
    MousePointer = 0
    end_time = Time
    lstResults.AddItem "All done, elapsed time=" + Format$(end_time - start_time, "hh:nn:ss")
End Sub

Private Sub btnWrite_Click()
    Dim hProfile As Long, rc As Long, fname As String, file As Integer, count As Long
    Dim start_time, end_time, szHive As String, hHive As Long

    fname = GetFile(True)
    If fname = "" Then Exit Sub
    
    start_time = Time
    file = FreeFile
    Open fname For Output As #file
    lstResults.Clear
    RgedSetSilent
    MousePointer = 11
    If optHive = True Then
        GetHive szHive, hHive
        rc = RgedOpenLocalHive(hHive, hProfile)
        lstResults.AddItem "Write " & szHive & " to " + fname
    Else
        rc = RgedLoadProfile("RGEDIT_TEST", txtProfile, hProfile)
        lstResults.AddItem "Write " + txtProfile + " to " + fname
    End If
    If rc <> 0 Then
        PrintError
    Else
        count = WriteData(file, hProfile, "")
        rc = RgedUnloadProfile(hProfile)
    End If
    MousePointer = 0
    Close #file
    end_time = Time
    lstResults.AddItem "All done, keys=" + Str$(count) + " elapsed time=" + Format$(end_time - start_time, "hh:nn:ss")
End Sub
Private Sub btnRead_Click()
    Dim hProfile As Long, rc As Long, fname As String, file As Integer, count As Long
    Dim start_time, end_time, szHive As String, hHive As Long

    If optHive = True Then
        GetHive szHive, hHive
        If hHive <> HKEY_CURRENT_USER Then
            lstResults.AddItem "Not allowed to read except for HKEY_CURRENT_USER"
            Exit Sub
        End If
    End If
    
    fname = GetFile(False)
    If fname = "" Then Exit Sub
    
    start_time = Time
    file = FreeFile
    Open fname For Input As #file
    lstResults.Clear
    RgedSetSilent
    MousePointer = 11
    If optHive = True Then
        GetHive szHive, hHive
        rc = RgedOpenLocalHive(hHive, hProfile)
        lstResults.AddItem "Read " & szHive & " from " + fname
    Else
        rc = RgedLoadProfile("RGEDIT_TEST", txtProfile, hProfile)
        lstResults.AddItem "Read " + txtProfile + " from " + fname
    End If
    If rc <> 0 Then
        PrintError
    Else
        DeleteKeys (hProfile)
        count = ReadData(file, hProfile)
        rc = RgedUnloadProfile(hProfile)
    End If
    MousePointer = 0
    Close #file
    end_time = Time
    lstResults.AddItem "All done, keys=" + Str$(count) + " elapsed time=" + Format$(end_time - start_time, "hh:nn:ss")
End Sub


Private Sub Form_Load()
    Dim i As Integer
    
    f_NumHives = 4
    ReDim f_szHives(4)
    ReDim f_hHives(4)
    f_szHives(0) = "HKEY_CURRENT_USER"
    f_szHives(1) = "HKEY_LOCAL_MACHINE"
    f_szHives(2) = "HKEY_USERS"
    f_szHives(3) = "HKEY_CLASSES_ROOT"
    f_hHives(0) = HKEY_CURRENT_USER
    f_hHives(1) = HKEY_LOCAL_MACHINE
    f_hHives(2) = HKEY_USERS
    f_hHives(3) = HKEY_CLASSES_ROOT
    For i = 0 To f_NumHives - 1
        lstHives.AddItem (f_szHives(i))
    Next
    lstHives.ListIndex = 0
End Sub

Private Sub Form_Resize()
    Dim i
    i = Me.ScaleWidth - lstResults.Left * 2
    If i > 0 Then lstResults.Width = i
    i = Me.ScaleHeight - lstResults.Top - lstResults.Left
    If i > 0 Then lstResults.Height = i
    i = Me.ScaleWidth - frmProfile.Left * 2
    If i > 0 Then frmProfile.Width = i
    i = Me.ScaleWidth - frmProfile.Left * 3 - txtProfile.Left
    If i > 0 Then txtProfile.Width = i
End Sub




